// MCELevelControlSecondary.cpp : implementation file
//

#include "stdafx.h"
#include "MCE.h"
#include "MCELevelControlSecondary.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMCELevelControlSecondary dialog


CMCELevelControlSecondary::CMCELevelControlSecondary(CWnd* pParent /*=NULL*/)
	: CDialog(CMCELevelControlSecondary::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMCELevelControlSecondary)
	m_nLayer1Scroll = 0;
	m_fLayer1Value = 0.0f;
	m_nLayer2Scroll = 0;
	m_fLayer2Value = 0.0f;
	m_bLayer2Visible = FALSE;
	m_nLayer3Scroll = 0;
	m_fLayer3Value = 0.0f;
	m_bLayer3Visible = FALSE;
	m_bLayer1Visible = FALSE;
	m_n2D_map_level = 0;
	m_b2D_map_Visible = FALSE;
	//}}AFX_DATA_INIT
	m_pMCEView = NULL;
}


void CMCELevelControlSecondary::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMCELevelControlSecondary)
	DDX_Control(pDX, IDC_SPIN_2D_LEVEL, m_wndSpin_2D_Level);
	DDX_Scroll(pDX, IDC_LAYER1_SCROLL, m_nLayer1Scroll);
	DDX_Text(pDX, IDC_LAYER1_VALUE, m_fLayer1Value);
	DDX_Scroll(pDX, IDC_LAYER2_SCROLL, m_nLayer2Scroll);
	DDX_Text(pDX, IDC_LAYER2_VALUE, m_fLayer2Value);
	DDX_Check(pDX, IDC_LAYER2_VISIBLE, m_bLayer2Visible);
	DDX_Scroll(pDX, IDC_LAYER3_SCROLL, m_nLayer3Scroll);
	DDX_Text(pDX, IDC_LAYER3_VALUE, m_fLayer3Value);
	DDX_Check(pDX, IDC_LAYER3_VISIBLE, m_bLayer3Visible);
	DDX_Check(pDX, IDC_LAYER1_VISIBLE, m_bLayer1Visible);
	DDX_Text(pDX, IDC_2D_LEVEL, m_n2D_map_level);
	DDX_Check(pDX, IDC_2D_MAP_VISIBLE, m_b2D_map_Visible);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMCELevelControlSecondary, CDialog)
	//{{AFX_MSG_MAP(CMCELevelControlSecondary)
	ON_BN_CLICKED(IDC_APPLY, OnApply)
	ON_BN_CLICKED(IDC_OK, OnClickedOk)
	ON_WM_HSCROLL()
	ON_WM_VSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMCELevelControlSecondary message handlers

BOOL CMCELevelControlSecondary::Create()
{
		return CDialog::Create(CMCELevelControlSecondary::IDD);
}

void CMCELevelControlSecondary::ApplyGraphicChanges()
{
	if (m_pMCEView != NULL) {
		// modeless case -- do not call base class OnOK
		UpdateData(TRUE);
		m_pMCEView->PostMessage(WM_APPLY_LC_CHANGES_SEC, IDOK);
	}
}

CMCELevelControlSecondary::CMCELevelControlSecondary(CView *pView)
{
	m_pMCEView = pView;
}

void CMCELevelControlSecondary::OnApply() 
{
	// TODO: Add your control notification handler code here
	CString strText;

	GetDlgItemText(IDC_LAYER1_VALUE, strText);

	m_fLayer1Value=(float)atof(strText);

	if (m_fLayer1Value < m_fMapMinimum) m_fLayer1Value = m_fMapMinimum;
	if (m_fLayer1Value > m_fMapMaximum) m_fLayer1Value = m_fMapMaximum;

	GetDlgItemText(IDC_LAYER2_VALUE, strText);

	m_fLayer2Value=(float)atof(strText);

	if (m_fLayer2Value < m_fMapMinimum) m_fLayer2Value = m_fMapMinimum;
	if (m_fLayer2Value > m_fMapMaximum) m_fLayer2Value = m_fMapMaximum;

	GetDlgItemText(IDC_LAYER3_VALUE, strText);

	m_fLayer3Value=(float)atof(strText);

	if (m_fLayer3Value < m_fMapMinimum) m_fLayer3Value = m_fMapMinimum;
	if (m_fLayer3Value > m_fMapMaximum) m_fLayer3Value = m_fMapMaximum;

	CMCELevelControlSecondary::RefreshScrollValues();
	CMCELevelControlSecondary::ApplyGraphicChanges();
}

void CMCELevelControlSecondary::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	if (m_pMCEView != NULL) {
		// modeless case -- do not call base class OnCancel
		m_pMCEView->PostMessage(WM_EXIT_LC_SEC, IDCANCEL);
	}
	else {
		CDialog::OnCancel(); // modal case
	}
}

void CMCELevelControlSecondary::OnClickedOk() 
{
	// TODO: Add your control notification handler code here
	if (m_pMCEView != NULL) {
		// modeless case -- do not call base class OnOK
		CMCELevelControlSecondary::OnApply();
		m_pMCEView->PostMessage(WM_EXIT_LC_SEC, IDOK);
	}
	else {
		CDialog::OnOK(); // modal case
	}
}

void CMCELevelControlSecondary::OnOK()
{
	// react on ENTER pressing in
	// empty area only
	// OnOk is procesed by OnClickedOK

	if (m_pMCEView != NULL) {
		// modeless case -- do not call base class OnOK
		CMCELevelControlSecondary::OnApply();
	}
	else {
		CDialog::OnOK(); // modal case
	}

}

void CMCELevelControlSecondary::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	
	int nTemp1, nTemp2;
	const int nFastRange=100;

	nTemp1 = pScrollBar->GetScrollPos();

	switch(nSBCode)
	{
		case SB_THUMBPOSITION:
			pScrollBar->SetScrollPos(nPos);
		break;

		case SB_LINELEFT: 
			nTemp2 = (nScrollMax-nScrollMin)/nFastRange;

			if((nTemp1 - nTemp2) >nScrollMin)
			{
				nTemp1-=nTemp2;
			}
			else
			{
				nTemp1=nScrollMin;
			}

			pScrollBar->SetScrollPos(nTemp1);
		break;

		case SB_LINERIGHT: 
			nTemp2 = (nScrollMax-nScrollMin)/nFastRange;

			if((nTemp1 + nTemp2) < nScrollMax)
			{
				nTemp1+=nTemp2;
			}
			else
			{
				nTemp1=nScrollMax;
			}

			pScrollBar->SetScrollPos(nTemp1);
		break;
	}

	// direct synchronization without UpdateData calll
	switch(pScrollBar->GetDlgCtrlID())
	{
		case IDC_LAYER1_SCROLL:
			m_nLayer1Scroll=nTemp1;
		break;
		case IDC_LAYER2_SCROLL:
			m_nLayer2Scroll=nTemp1;
		break;
		case IDC_LAYER3_SCROLL:
			m_nLayer3Scroll=nTemp1;
		break;		
	}

	CMCELevelControlSecondary::RefreshLevelValues();

	CMCELevelControlSecondary::ApplyGraphicChanges();
}

void CMCELevelControlSecondary::RefreshLevelValues()
{
	float fScale;

	fScale=(m_fMapMaximum-m_fMapMinimum)/(nScrollMax-nScrollMin);

	CString strText;

	// text synchronization without UpdateData calll

    //1
	m_fLayer1Value= m_fMapMinimum + fScale*m_nLayer1Scroll;		
	strText.Format("%8.4f", m_fLayer1Value);
	SetDlgItemText(IDC_LAYER1_VALUE, strText);

	//2
	m_fLayer2Value= m_fMapMinimum + fScale*m_nLayer2Scroll;		
	strText.Format("%8.4f", m_fLayer2Value);
	SetDlgItemText(IDC_LAYER2_VALUE, strText);

	//3
	m_fLayer3Value= m_fMapMinimum + fScale*m_nLayer3Scroll;		
	strText.Format("%8.4f", m_fLayer3Value);
	SetDlgItemText(IDC_LAYER3_VALUE, strText);

}

void CMCELevelControlSecondary::RefreshScrollValues()
{
	int nValue;
	float fScale;

	fScale=(nScrollMax-nScrollMin)/(m_fMapMaximum-m_fMapMinimum);

	CScrollBar* pSB;

	pSB = (CScrollBar*) GetDlgItem(IDC_LAYER1_SCROLL);
	nValue=nScrollMin+(int)(fScale*(m_fLayer1Value-m_fMapMinimum));
	pSB->SetScrollPos(nValue);
	m_nLayer1Scroll=nValue;

	pSB = (CScrollBar*) GetDlgItem(IDC_LAYER2_SCROLL);
	nValue=nScrollMin+(int)(fScale*(m_fLayer2Value-m_fMapMinimum));
	pSB->SetScrollPos(nValue);
	m_nLayer2Scroll=nValue;


	pSB = (CScrollBar*) GetDlgItem(IDC_LAYER3_SCROLL);
	nValue=nScrollMin+(int)(fScale*(m_fLayer3Value-m_fMapMinimum));
	pSB->SetScrollPos(nValue);
	m_nLayer3Scroll=nValue;
}

BOOL CMCELevelControlSecondary::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	CScrollBar* pSB;
	CString strText;
		
	strText.Format("%f", m_fMapMinimum);
	SetDlgItemText(IDC_MAP_MINIMUM, strText);

	strText.Format("%f", m_fMapMaximum);
	SetDlgItemText(IDC_MAP_MAXIMUM, strText);

	pSB = (CScrollBar*) GetDlgItem(IDC_LAYER1_SCROLL);
	pSB->SetScrollRange(nScrollMin, nScrollMax);

	pSB = (CScrollBar*) GetDlgItem(IDC_LAYER2_SCROLL);
	pSB->SetScrollRange(nScrollMin, nScrollMax);

	pSB = (CScrollBar*) GetDlgItem(IDC_LAYER3_SCROLL);
	pSB->SetScrollRange(nScrollMin, nScrollMax);

	RefreshScrollValues();
	
	return TRUE;  // return TRUE unless you set the focus to a control
}


void CMCELevelControlSecondary::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default

	// immediate reaction on 2D map level change ...

	CMCELevelControlSecondary::ApplyGraphicChanges();
	
	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}
